#ifndef MODULE_API_H
#define MODULE_API_H

#define MAX_API_PROVIDERS	100

/*
	Provide a generic mechanism to implement API serialisation.
	This allow inter-module/inter-machine api to be implement

	Each API provider is free to implement this class, allowing its
	API to be reach from other machine. This is mainly used by the
	netadm module, acting both as a client or server.
*/
class MODULE_API_SERIAL{
public:
	virtual int exec (const char *func, int nbparm, const char *parms[],
		SSTRINGS &res)=0;
	/*~PROTOBEG~ MODULE_API_SERIAL */
public:
	virtual bool is_api_ok (void);
	virtual ~MODULE_API_SERIAL (void);
	/*~PROTOEND~ MODULE_API_SERIAL */
};

#endif

